/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

static conf_error (e1, op, e2)
int e1, e2;
Node *op;
{
	int top = op->com.type;

	switch (node_class (top)) {
	case TERM:
		sprintf (serr, "non-conformal expression: rank %d %s rank %d"
		             , e1, op->com.str, e2);
		break;

	case LIT:
		sprintf (serr, "non-conformal expression: rank %d %c rank %d"
		             , e1, top, e2);
		break;

#ifdef CHECK
	default:
		SYSERR;
#endif
	}

	fatal (serr);
}

int conf_shape (e1, op, e2)  /* checks that the shapes are conformal */
Node *e1, *op, *e2;
{
	int r1, r2;

	if (e1 == NN || e2 == NN)
		return;

	r1 = RANK_FROM_SHAPE (e1->com.typ->shape);
/*	r2 = RANK_FROM_SHAPE (e2->com.typ->shape); */
       if(e2==NN)
          r2=0;
       else
 	r2 = RANK_FROM_SHAPE (e2->com.typ->shape);   /* SIL */

	if (r1 != 0 && r2 != 0 && r1 != r2) {
		conf_error (r1, op, r2);
		return;
	}
/* I REMOVE
	if (op == &Eq && r1 == 0 && r2 != 0) {
		sprintf (serr, "expression of rank %d assigned to scalar", r2);
		fatal (serr);
	}
*/
/* it must also check the shapes, for the moment only checks the rank */
}
